import "Turbine";

MinstrelBuffCommand = Turbine.ShellCommand();

function MinstrelBuffCommand:Constructor(MinstrelBuffMain)
	Turbine.ShellCommand(self);
	self.MinstrelBuffMain = MinstrelBuffMain;
end

function MinstrelBuffCommand:Execute( command, arguments )
	local operation = self:GetFirstArgument(arguments);

	if (operation == nil) then
		Turbine.Shell.WriteLine(self:GetHelp());
		return
	end

	if ( operation == "on" ) then
		self.MinstrelBuffMain:ShowWindow();
	elseif( operation == "off" ) then
		self.MinstrelBuffMain:HideWindow();
	elseif( operation == "list" ) then
		self.MinstrelBuffMain:WriteBuffsToChat();
	elseif ( operation == "unlock" ) then
		self.MinstrelBuffMain:UiLocked(false);
	elseif ( operation == "lock" ) then
		self.MinstrelBuffMain:UiLocked(true);
	elseif( operation == "de" ) then
		self.MinstrelBuffMain:SetLanguage ("de");
	elseif( operation == "en" ) then
		self.MinstrelBuffMain:SetLanguage ("en");
	else
		Turbine.Shell.WriteLine( "Invalid operation: " .. operation );
	end
end

function MinstrelBuffCommand:GetFirstArgument(arguments)
	-- No arguments, return nil.
	if ( ( arguments == nil ) or ( string.len( arguments ) == 0 ) ) then
		return nil;
	end

		-- Parse the arguments into a list.
	local argumentList = { };
	local index = 1;

	for word in arguments:gmatch( "%w+" ) do
		argumentList[index] = word;
		index = index + 1;
	end

	-- Extract the operation and example name.
	local operation = string.lower( argumentList[1] );
	return operation;
end

function MinstrelBuffCommand:GetHelp()
	local helpText = "/minstrelbuff [on|off|list|lock|unlock|de|en]\n";
	helpText = helpText .. "/mb [on|off|list|lock|unlock|de|en]\n\n";	
	helpText = helpText .. "Shows the active ballads and anthems.";
	return helpText;
end

function MinstrelBuffCommand:GetShortHelp()
	return "Shows the active ballads and anthems.";
end

function MinstrelBuffCommand:ShowHelpText()
	Turbine.Shell.WriteLine( self:GetHelp() );
end