
Settings = class();

function Settings:Constructor()
	self:Load();	
end

function Settings:Load()
	self.settingsTable = Turbine.PluginData.Load(Turbine.DataScope.Character, "MinstrelBuff");
	if (self.settingsTable == nil) then
		self.settingsTable = {};
		self.settingsTable["MainPosX"] = 100;
		self.settingsTable["MainPosY"] = 100;
		self.settingsTable["EffectLocalizationNames"] = "en";
	end
	--Turbine.Shell.WriteLine( "Settings:Load" );
end

function Settings:Save()
	if (self.settingsTable ~= nil) then
		Turbine.PluginData.Save(Turbine.DataScope.Character, "MinstrelBuff", self.settingsTable);
	end
end

function Settings:GetMainPosX()
	if (self.settingsTable["MainPosX"] ~= nil) then
		return self.settingsTable["MainPosX"];
	else
		return 200;
	end
end

function Settings:GetMainPosY()
	if (self.settingsTable["MainPosY"] ~= nil) then
		return self.settingsTable["MainPosY"];
	else
		return 200;
	end
end

function Settings:SetMainPos(posx, posy)
	self.settingsTable["MainPosX"] = posx;
	self.settingsTable["MainPosY"] = posy;
	self:Save();
end

function Settings:GetEffectLocalizationNames()
	if (self.settingsTable["EffectLocalizationNames"] ~= nil) then
		return self.settingsTable["EffectLocalizationNames"];
	else
		return "en";
	end
end

function Settings:SetEffectLocalizationNames(language)
	self.settingsTable["EffectLocalizationNames"] = language;
	self:Save();
end