import "Turbine.UI.Lotro"
import "MinstrelBuffs.MinstrelBuffWindow.Class";

TimerControl = class(Turbine.UI.Control);

function TimerControl:Constructor()
	Turbine.UI.Control.Constructor(self);

	local backColor = Turbine.UI.Color();
    backColor.R = 1.0;
    backColor.G = 1.0;
    backColor.B = 1.0;
    backColor.A = 1.0;
	self:SetBackColor(backColor);
	self:SetSize( 34, 10 );
end

-- Properties
function TimerControl:SetStartTime(value)
	self.startTime = value;
	self:RefreshDisplayBehaviour();
end

function TimerControl:GetStartTime()
	return self.startTime;
end

function TimerControl:SetDuration(value)
	self.duration = value;
	self:RefreshDisplayBehaviour();
end

function TimerControl:GetDuration()
	return self.duration;
end

-- Functions
function TimerControl:GetRemainingPercent()
	local gameTime = Turbine.Engine.GetGameTime();
	if (self:GetStartTime() == nil or self:GetDuration() == nil) then
		return 0;
	end
    local elapsedTime = gameTime - self:GetStartTime();
    local percentComplete = elapsedTime / self:GetDuration();
	local remainingPercent = 1 - percentComplete;
	return remainingPercent;
end

function TimerControl:RefreshDisplayBehaviour()
	local remainingPercent = self:GetRemainingPercent();
	if (remainingPercent > 0) then
		self:SetWantsUpdates(true);
	end
	
end

function TimerControl:Update()
	local remainingPercent = self:GetRemainingPercent();
	self:SetWidth(remainingPercent * 34);
	
	-- Deactivate Update, when timer is elapsed.
	if (remainingPercent <= 0) then
		self:SetWantsUpdates(false);
	end
end
